const { sum } = require("lodash");

var roleHarvester = {

    minimum_parts: [WORK, MOVE, CARRY],
    recommended_parts: [WORK, MOVE, CARRY],
    min_cost: sum([BODYPART_COST["work"], BODYPART_COST["move"], BODYPART_COST["carry"]]),

    /**
     * Orders the given spawn to create a creep fitting for this role according to the recommended_parts and if impossible use minimum_parts instead
     * @param {spawn} spawn
     * @param {string} postfix string to postfix to the creep
     * @param {string} owner_id strind id of who shall be entered as owner of the new creep
     * 
     * @return {string} name of the new creep
     */
    spawn: function(spawn, postfix, owner_id) {
        if (spawn.spawnCreep(this.recommended_parts, "harvester-"+postfix, {dryRun: true}) === OK) {
            console.log("roleHarvester: Spawn "+spawn.name+" is creating harvester-"+postfix+" with recommended parts ...");
            spawn.spawnCreep(this.recommended_parts, "harvester-"+postfix, {memory: {"owner": owner_id, "role": "Harv"}});
        }
        else if (spawn.spawnCreep(this.minimum_parts, "harvester-"+postfix, {dryRun: true}) === OK) {
            console.log("roleHarvester: Spawn "+spawn.name+" is creating harvester-"+postfix+" with minimum parts ...");
            spawn.spawnCreep(this.minimum_parts, "harvester-"+postfix, {memory: {"owner": owner_id, "role": "Harv"}});
        }
        else {
            console.log("roleHarvester: Spawn \""+spawn.name+"\" couldn't afford a harvester! D:");
            throw "Not enough energy!";
        }

        return "harvester-"+postfix;
    },

    /**
     * Runs the logic and actions of the harvester
     * @param {string} creep_name 
     */
    run: function(creep_name) {
        console.log("roleHarvester: run() " + creep_name)
    },
};

module.exports = roleHarvester;