var setup_overlord = require('overlords_overlord');
var harvester = require('creeps_harvester');

/**
 * Overlord that sets up a room given only a single spawn with a minimum energy to build one harvester.
 * 
 * Setup is considered finished once 3 spawns have been built and at least one creep is maintaining the RCL
 */


/** Checks the room and sets out the tasks to achieve the goal */
setup_overlord.prototype.run = function () {  // TODO somehow these aren't changing anything
    console.log("SetupOverlord: Running \""+this.id+"\"! :) Chilling for now ...");
    console.log("SetupOverlord: has the following underlings: ", this.underlings['spawns'], this.underlings['creeps']);
    
    if (this.underlings['creeps'].length === 0 && this.underlings['spawns'].length === 0) {  // got NOTHING to work with
        console.log("SetupOverlord: ERROR "+this.id+" has nothing! ;W;");
    }
    else if (this.underlings['creeps'].length === 0 && this.underlings['spawns'].length > 0) {
        console.log("SetupOverlord: \""+this.id+"\" is trying to creat a harvester ...");

        let spawn_name = null;
        for (spawn_name of this.underlings['spawns']) {
            let spawn = Game.spawns[this.underlings['spawns']];
            if (spawn.store[RESOURCE_ENERGY] > harvester.min_cost) { // can afford a harvester
                console.log("SetupOverlord: Spawn "+spawn.name+" can afford a harvester! ("+harvester.min_cost+") \\o/");
                let new_harvester_name = harvester.spawn(spawn, this.id+"-0", this.id);
                this.add_creep(new_harvester_name);
                break;
            }
        }
        //spawn = Game.spawns[this.underlings['spawns']]
    }
};

module.exports = setup_overlord;